comment " FuncfindClosestTown.sqf - Find the closest to player excuting the script [player]";
comment " Script should work on any island providing the island config file includes the 'type'. for towns";
comment " By Hoz - July 2007";
comment " Version v.3 - slightly altered for the purpose of checking a pos array opposed to a unit";  
private["_unit", "_towns", "_mindist", "_maxdist", "_dist", "_mindistidx", "_typecity", "_cfgTowns", "_i", "_cfgPath", "_ntowns",  "_postown", "_return", "_msg", "_dir", "_FunctionMode"];

_unit = _this select 0;
_maxdist = _this select 1;
_towns=[];
_mindist    = 99999;
_dist       = 99999;
_mindistidx = -1;
_typecity   = "";
_cfgTowns=(configFile >> "cfgWorlds" >> WorldName >> "Names");
for "_i" from 0 to ((Count _cfgTowns)-1) do
{
   _cfgPath = _cfgTowns Select _i;
   _typecity =  getText (_cfgPath >> "type");
   if ((_typecity == "NAMECITY") || (_typecity == "NAMEVILLAGE") || (_typecity == "NAMECITYCAPITAL") || (_typecity == "NAMELOCAL")) then 
   {
      _towns Set [_i,[getText (_cfgPath >> "name"),getArray (_cfgPath >> "position"), _typecity]];			
   };
};

_ntowns = count _towns;
for [{_i=0},{_i < _ntowns},{_i = _i + 1}] do 
{
   _postown = ((_towns select _i) select 1);
   _dist = _unit distance _postown;
   if ((_dist < _mindist) && (_dist < _maxdist)) then 
   {
      _mindist = _dist;
      _mindistidx = _i;
   };
};
if (_mindistidx != -1) then 
{
   _postown = ((_towns select _mindistidx) select 1);
   _dir = ((_postown select 0)-(_unit select 0)) atan2 ((_postown select 1)-( _unit select 1));

   if ((_dir < 23) && (_dir > -23)) then
   {
      _msg = "North";     
   }
   else
   {
      if ((_dir >= 23) && (_dir < 68)) then
      {
         _msg = "North East";     
      }
      else
      {
         if ((_dir >= 68) && (_dir < 113)) then
         {
            _msg = "East";     
         }
         else
         {
            if ((_dir >= 113) && (_dir < 136)) then
            {
               _msg = "East";     
            }
            else
            {
               if ((_dir >= 136) && (_dir < 159)) then
               {
                  _msg = "South East";     
               }
               else
               {
                  if ((_dir >= 159) || (_dir < -158)) then
                  {
                     _msg = "South";     
                  }
                  else
                  {
                     if ((_dir >= -158) && (_dir < -113)) then
                     {
                        _msg = "South West";     
                     }
                     else
                     {
                        if ((_dir >= -113) && (_dir < -68)) then
                        {
                           _msg = "West";
                        }
                        else
                        {
                           _msg = "North West";
                        };
                     };
                  };   
               };
            };
         };
      };
   };

   _return = [((_towns select _mindistidx) select 0), _msg, _mindist];
}
else 
{
   _return = ["", "", 0];
};

_return

