/* 
 ofpec_AirportEvents.sqf v1.0
 August 2007 Hoz 
*/


private ["_event", "_params", "_lb_index"];
_event = _this select 0;
_params = _this select 1;


_lb_index =0;
_OFPEC_ASidc = 108;
_OFPEC_MAP = 109;

// hint format["%1", _this];

switch (_event) do
{
   case "onLoad":
   {	
      _display = _params select 0;
      ofpec_airportdisp = _display;
      AirportArray = [];

      playSound "ofpec_destination";

      _cfgILSP = [];
      _cfgILSD = [];
      _cfgAirP =(configFile >> "cfgWorlds" >> worldName );
      _cfgILSP = getArray (_cfgAirP  >> "ilsPosition");
      _cfgILSD = getArray (_cfgAirP  >> "ilsDirection");
      _cfgName = [_cfgILSP, 2000] call ClosestTown;
      if (_cfgName select 0 == "") then 
      {
         _cfgName = [format["%1Airstrip0", worldname],_cfgILSP, _cfgILSD];
      };
      AirportArray set [0, [format["%1", (_cfgName select 0)], _cfgILSP, _cfgILSD]];
      _cfgAirP =(configFile >> "cfgWorlds" >> WorldName >> "SecondaryAirports");

      for "_i" from 0 to ((Count _cfgAirP)-1) do
      {
         _k = _i + 1;
         _cfgILSP = getArray (_cfgAirP Select _i >> "ilsPosition");
         _cfgILSD = getArray (_cfgAirP Select _i >> "ilsDirection");
         _cfgName = [_cfgILSP, 2000] call ClosestTown;
         if (_cfgName select 0 == "") then 
         {
            _cfgname = [format["%1Airstrip%2", worldname, _k],_cfgILSP, _cfgILSD];
         };
         AirportArray set [_k, [format["%1", (_cfgName select 0)], _cfgILSP, _cfgILSD]];
      };
      for [{_i=0},{_i < (count AirportArray)},{_i = _i + 1}] do
      {
         _lb_index = (_display displayCtrl _OFPEC_ASidc) lbAdd format["%1 - %2km", ((AirportArray select _i) select 0), (player distance ((AirportArray select _i) select 1)) call ofpec_m_to_km];
      };
		
      (_display displayCtrl _OFPEC_ASidc) lbSetCurSel 0;
      (_display displayCtrl _OFPEC_ASidc) ctrlSetEventHandler ["LBSelChanged", "[""OFPEC_ASLstChnge"", _this] call ofpec_AirportEvents"];
      (ofpec_airportdisp displayCtrl _OFPEC_MAP) ctrlMapAnimAdd [0.01, 1, ((AirportArray select 0) select 1)];
      ctrlMapAnimCommit (ofpec_airportdisp displayCtrl _OFPEC_MAP);
   };



   case "OFPEC_ASLstChnge":
   {
      _itemSelected = (_params select 1);

//      hint format ["You've Selected:%1\nILSPos:%2\nILSDir:%3\nDist:%4km", ((AirportArray select _itemSelected) select 0), ((AirportArray select _itemSelected) select 1), ((AirportArray select _itemSelected) select 2), (player distance ((AirportArray select _itemSelected) select 1))];


      (ofpec_airportdisp displayCtrl _OFPEC_MAP) ctrlMapAnimAdd [0.01, 1, ((AirportArray select _itemSelected) select 1)];
      ctrlMapAnimCommit (ofpec_airportdisp displayCtrl _OFPEC_MAP);

   };



   case "OFPEC_ACTIVATEILS":
   {      
      _itemSelected = lbCurSel (ofpec_airportdisp displayCtrl _OFPEC_ASidc);
      if (_itemSelected >= 0) then
      {
         closeDialog 0;
         ofpec_airfielselector_vehicle removeAction (ofpec_airfielselector_action);
         [ofpec_airfielselector_vehicle, ((AirportArray select _itemSelected) select 0), ((AirportArray select _itemSelected) select 1),((AirportArray select _itemSelected) select 2)]execVM"ofpec_ils\ofpec_ils.sqf";
      };
   };

   case "OFPEC_CLOSESELECTOR":
   {
      closeDialog 0;
   };

};


